
#   package-load.tcl   -  core 

proc init-packages_8.3 {} {

    global env
    
    puts stdout "Setting up access for additional packages"

#    Incr Tcl packges

    set env(ITCL_LIBRARY) [file join $env(MIDASBASE) packages itcl3.2]
    package ifneeded Itcl 3.2 "load itcl32[info sharedlibextension] Itcl"

    set env(ITK_LIBRARY) [file join  $env(MIDASBASE) packages itk3.2]
    package ifneeded Itk 3.2 "load itk32[info sharedlibextension] Itk"

#    Incr Widgets package

    set dir [file join $env(MIDASBASE) packages iwidgets4.0.2]
    source [file join $dir pkgIndex.tcl]

#    Tree package

    set env(TREE_LIBRARY) [file join  $env(MIDASBASE) packages Tree8.0.3]

    switch $env(platform)  {
       windows {package ifneeded Tree 8.0.3 "load Tree803.dll Tree"}
       unix    {package ifneeded Tree 8.0.3 "load libTkTree.so Tree"}
       default {puts stderr "package Tree not available for platform $env(platform)"}
    }
    
}

proc init-packages_8.4 {} {
    global env

#    puts stdout "Setting up access for additional packages"
    
#    Incr Tcl packges

    if {$env(os) == "Windows NT"} then {set os Win} else {set os $env(os)}

    set env(ITCL_LIBRARY) [file join $env(MIDASBASE) packages $os itcl3.2]
    load-package itcl3.2

    set env(ITK_LIBRARY) [file join $env(MIDASBASE) packages $os itk3.2]
    load-package itk3.2
    
#    packages which have no OS dependency

    set packages [list TclHttpd3.4.2]
    
    foreach p $packages {
        set dir [file join $env(MIDASBASE) packages $p]
        if {[file isdir $dir]} then {
            source [file join $dir pkgIndex.tcl]
        }
    
#        puts stdout "package $p available"
    }
    
#    packages which are OS dependent
    
    switch $os {
        Win    {
            load-package dde1.2
            load-package reg1.1
            load-package TclScript
            load-package tcom
        }
        SunOS  {
        }
        Linux  {
        }
    }
    
#    packages which are available for all OSes

    set packages [list bwidget1.6 Img1.3 iwidgets4.0.2 Memchan2.2 Mk4tcl snack2.2 tbcload1.4 Tcldom2.6 \
        tcldomxml2.6 Tclexpat2.6 tcllib1.5 tclsoap1.6.6 tclx8.4 Tclxml2.6 Tclxslt2.6 Tkhtml2.0 Tktable2.8 Trf2.1 vfs1.2]

    foreach p $packages {load-package $p}
    
}

proc load-package {package} {
    global env

    if {$env(os) == "Windows NT"} then {set os Win} else {set os $env(os)}

    set dir [file join $env(MIDASBASE) packages $os $package]
    if {[file isdir $dir]} then {
        source [file join $dir pkgIndex.tcl]
#       puts stdout "package $package available"
    }
}


proc init-packages {} {
    global env

    if {![file isdir [file join $env(MIDASBASE) packages]]} then {return}

     set version [info tclversion]
     
     switch $version {
        8.3   {init-packages_8.3}
        8.4   {init-packages_8.4}
        default {puts stderr "no additional packages supported for Tcl version $version"}
     }
}

